unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Area: TPaintBox;
    Timer1: TTimer;
    btAlvo: TSpeedButton;
    SpeedButton1: TSpeedButton;
    Mensag: TLabel;
    Placar: TLabel;
    Alvo: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure btAlvoClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  JPx,JPy: integer;  {Coordenadas da barra preta}
  Status: byte;      {Status de funcionamento}
  Contador: integer; {Conta as partidas}
  Acertou: integer;  {Quantas vezes acertou}

implementation
{$R *.DFM}

procedure PreparaJogo;
begin
  with Form1 do begin
    JPx:= 0;                     {Coluna 0}
    JPy:= Area.Height-2;         {ltima linha da Area de jogo}
    Status:= 0;                  {0 = O jogo pode comear}
    Timer1.Enabled:= True;       {Ativa o Timer}
    Area.Canvas.Pen.Color:= clSilver;    {Cor da tinta}
    Area.Canvas.Brush.Color:= clSilver;  {Cor do papel}
    {Apaga toda a rea do jogo}
    Area.Canvas.Rectangle(0,0,Area.Width,Area.Height);
    Area.Canvas.Pen.Color:= clBlack;
    Area.Canvas.Brush.Color:= clBlack;
    {Imprime o primeiro ponto da barra (4 x 4 pixels)}
    Area.Canvas.Rectangle(JPx,JPy,JPx+4,JPy+2);
    {Sorteia uma posio aleatria para o Alvo}
    Alvo.Top:= 20 + Random(Area.Height - 40);
    Mensag.Caption:= 'Subindo...'; {Avisa que est comeando}
    inc(Contador);   {Mais uma jogada}
  end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  PreparaJogo;
end;

procedure TForm1.btAlvoClick(Sender: TObject);
begin
  Status:= 1;   {Ok, disparou}
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if Status = 2 then begin   {Se acabou o disparo...}
    if (JPy < Alvo.Top-Area.Top+4)
      {Se a barra estiver acima do alvo}
      or (JPy > Alvo.Top-Area.Top+8) then
      {ou se ela estiver abaixo, ento...}
      Mensag.Caption:= 'Errrroooouuuuu!!!!!!'
    else begin;
      {caso contrrio}
      Mensag.Caption:= 'Na mosca!';
      inc(Acertou);   {Mais um acerto}
    end;
    Placar.Caption:= 'De '+IntToStr(Contador)+
    ', acertou '+IntToStr(Acertou);
    {Monta o placar}
    Timer1.Enabled:= False;
  end; {Desliga o Timer}
  if Status = 0 then JPy:= JPy - 2;
  {Se est subindo, suba mais 2 pixels}
  if Status = 1 then JPx:= JPx + 6;
  {Se est indo em direo ao alvo, ande mais 6 pixels}
  if Status <> 2 then begin
  {Se no estiver parado, faa um ponto da barra}
  Area.Canvas.Brush.Color:= clBlack;
  Area.Canvas.Rectangle(JPx,JPy,JPx+6,JPy+6); end;
  if JPx > Area.Width - 8 then Status:= 2;
  {Se chegou no canto da rea, acabou a partida}
end;

end.
